"use strict";
{
    const C3 = self.C3;
    C3.Plugins.Sparsha_External_Image.Instance = class External_ImageInstance extends C3.SDKWorldInstanceBase
    {
        constructor(inst, properties)
        {
            super(inst);

            //this._testProperty = 0;

            if (properties)
            {
                this.clearAll = properties[0];
            }
            this.PluginCnds = C3.Plugins.Sparsha_External_Image.Cnds;

            this.isLoaded = false;
            this.isNew = false;

            this.texture = null;
            //this.myImageBitmap = null;
            //this.myIID = null;
            this.myID = null;
            this.myW = 0;
            this.myH = 0;

            //console.log(this._inst.GetIID())

            if (globalThis.myImageBitmap == undefined) globalThis.myImageBitmap = {};
            if (globalThis.myImageBitmap[this._objectClass._name] == undefined) globalThis.myImageBitmap[this._objectClass._name] = {}
        }

        Release()
        {
            if (this.clearAll && this._runtime.GetObjectCount() === 0) delete globalThis.myImageBitmap[this._objectClass._name];
            super.Release();
        }

        Draw(renderer)
        {
            var texture = null
            var rcTex = null
            var imageInfo = null
            var myImageBitmapNow = undefined;
            if (this.isLoaded && globalThis.myImageBitmap[this._objectClass._name] !== undefined)
            {
                myImageBitmapNow = globalThis.myImageBitmap[this._objectClass._name][this.myID];
                if (myImageBitmapNow != undefined)
                {
                    this.myW = myImageBitmapNow.width;
                    this.myH = myImageBitmapNow.height;
                }
            }

            var self = this;

            function setOriginImage()
            {
                imageInfo = self._objectClass.GetImageInfo();
                self.myW = imageInfo._width;
                self.myH = imageInfo._height;
                texture = imageInfo.GetTexture();
                rcTex = imageInfo.GetTexRect();
            }

            function setMyImage()
            {
                renderer.UpdateTexture(myImageBitmapNow, self.texture,
                {});
                texture = self.texture;
                rcTex = new C3.Rect(0, 0, 1, 1)
            }

            if (this.isLoaded && this.isNew)
            {
                if (myImageBitmapNow === undefined) setOriginImage()
                else
                {
                    this.isNew = false;
                    if (this.texture)
                    {
                        renderer.DeleteTexture(this.texture);
                    }
                    this.texture = renderer.CreateDynamicTexture(this.myW, this.myH,
                    {
                        mipMap: false
                    });

                    setMyImage();
                }
                //this.Trigger(this.PluginCnds.OnLoaded);
            }
            else if (this.isLoaded)
            {
                if (myImageBitmapNow === undefined) setOriginImage()
                else setMyImage();
            }
            else
            {
                setOriginImage();
            }

            if (!texture) return; // dynamic texture load which hasn't completed yet; can't draw anything

            const wi = this.GetWorldInfo();
            const quad = wi.GetBoundingQuad();

            renderer.SetTexture(texture);

            if (this._runtime.IsPixelRoundingEnabled())
            {
                const ox = Math.round(wi.GetX()) - wi.GetX();
                const oy = Math.round(wi.GetY()) - wi.GetY();
                tempQuad.copy(quad);
                tempQuad.offset(ox, oy);
                renderer.Quad3(tempQuad, rcTex);
            }
            else
            {
                renderer.Quad3(quad, rcTex);
            }
        }

        SaveToJson()
        {
            return {
                // data to be saved for savegames
            };
        }

        LoadFromJson(o)
        {
            // load state for savegames
        }

        GetDebuggerProperties()
        {
            return [
            {
                title: "External_Image",
                properties: [
                    //{name: ".current-animation",	value: this._currentAnimation.GetName(),	onedit: v => this.CallAction(Acts.SetAnim, v, 0) },
                ]
            }];
        }

        // timeline support
        GetPropertyValueByIndex(index)
        {
            return 0;
        }

        SetPropertyValueByIndex(index, value)
        {
            //set property value here
        }
    };
}